with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLObjectElement5_Interface is

   procedure Initialize (This : in out IHTMLObjectElement5_Type) is
   begin
      Set_IID (This, IID_IHTMLObjectElement5);
   end Initialize;

   function Pointer (This : IHTMLObjectElement5_Type)
     return Pointer_To_IHTMLObjectElement5
   is
   begin
      return To_Pointer_To_IHTMLObjectElement5 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLObjectElement5_Type;
                     Pointer : in     Pointer_To_IHTMLObjectElement5)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_object
     (This : IHTMLObjectElement5_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_object
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_object;

   function Get_object
     (This : IHTMLObjectElement5_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_object
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_object;

end MSHTML.IHTMLObjectElement5_Interface;

